#ifndef TOMO_H
#define TOMO_H
#include <sys/types.h>

/* default memory limit */

#ifndef MAXMEM
#define MAXMEM 1500000000
#endif
#define MAX_STRING_LEN (255)

#define N_NB 6 

#ifdef T_USHORT
typedef ushort tomo_t ;
#elif T_FLOAT
typedef float tomo_t ;
#elif T_ULONG
typedef unsigned long tomo_t ;
#else
#warning
#warning
#warning "WARNING: tomo_t datatype not specified."
#warning "Defaulting to T_FLOAT"
#warning
#warning
#define T_FLOAT
typedef float tomo_t;
#endif

#ifndef OUTSIDE
#define OUTSIDE ((tomo_t)(0))
#endif

#define R_BDY 65535
#define R_UNP 3000 
#define R_YES 1000
#define R_OUTS 4000
#define R_NO  2000

/* useful small functions */
#ifndef MAX
#define MAX(A,B) ( (A) > (B) ? (A) : (B))
#endif /* MAX */

#ifndef MIN
#define MIN(A,B) ( (A) < (B) ? (A) : (B))
#endif /* MIN */

#include "ctrl.h"


typedef struct tdata_struct{
   char * filename;
   int tsizes[3];
   int origin[3];
   double resolution;
   int ndata;
   int zslice;
   tomo_t *tdata;
} TOMODATA;

typedef struct rdata_struct{
   int nregions;
   int *histo;
} REGDATA;

typedef struct adata_struct{
   int count;
   int min[3];
   int max[3];
}Adata;

typedef struct apdata_struct{
   int naps;
   Adata * adata;
} APDATA;
#endif /*TOMO_H*/

